Index: main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.py	(revision 9217)
@@ -23,5 +23,5 @@
 from hurry.workflow.interfaces import InvalidTransitionError
 from waeup.kofa.browser.resources import datatable
-from waeup.kofa.browser import KofaPage, KofaAddFormPage, NullValidator
+from waeup.kofa.browser.layout import KofaPage, KofaAddFormPage, NullValidator
 from waeup.kofa.browser.breadcrumbs import Breadcrumb
 from waeup.kofa.browser.viewlets import (
Index: main/waeup.kofa/trunk/src/waeup/kofa/app.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/app.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/app.py	(revision 9217)
@@ -18,14 +18,13 @@
 import grok
 from zope.authentication.interfaces import IAuthentication
-from zope.component import getUtilitiesFor
+from zope.component import getUtility, getUtilitiesFor
 from zope.component.interfaces import ObjectEvent
 from zope.pluggableauth import PluggableAuthentication
 from waeup.kofa.authentication import setup_authentication
 from waeup.kofa.datacenter import DataCenter
-from waeup.kofa.students.container import StudentsContainer
-from waeup.kofa.hostels.container import HostelsContainer
 from waeup.kofa.mandates.container import MandatesContainer
 from waeup.kofa.interfaces import (
-    IUniversity, IKofaPluggable, IObjectUpgradeEvent, )
+    IUniversity, IKofaPluggable, IObjectUpgradeEvent, IJobManager,
+    VIRT_JOBS_CONTAINER_NAME)
 from waeup.kofa.userscontainer import UsersContainer
 from waeup.kofa.utils.logger import Logger
@@ -55,4 +54,7 @@
         the like.
         """
+        from waeup.kofa.students.container import StudentsContainer
+        from waeup.kofa.hostels.container import HostelsContainer
+
         self['users'] = UsersContainer()
         self['datacenter'] = DataCenter()
@@ -69,4 +71,9 @@
             plugin.setup(self, name, self.logger)
         return
+
+    def traverse(self, name):
+        if name == VIRT_JOBS_CONTAINER_NAME:
+            return getUtility(IJobManager)
+        return None
 
     def updatePlugins(self):
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 9217)
@@ -29,10 +29,9 @@
 from zope.schema.interfaces import RequiredMissing, ConstraintNotSatisfied
 from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
-from waeup.kofa.app import University
 from waeup.kofa.image import KofaImageFile
 from waeup.kofa.imagestorage import DefaultFileStoreHandler
 from waeup.kofa.interfaces import (
     IObjectHistory, IFileStoreHandler, IFileStoreNameChooser, IKofaUtils,
-    IExtFileStore, IPDF, IUserAccount)
+    IExtFileStore, IPDF, IUserAccount, IUniversity)
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.students.vocabularies import RegNumNotInSource
@@ -189,5 +188,5 @@
     """A catalog indexing :class:`Applicant` instances in the ZODB.
     """
-    grok.site(University)
+    grok.site(IUniversity)
     grok.name('applicants_catalog')
     grok.context(IApplicant)
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 9217)
@@ -38,6 +38,8 @@
     INITIALIZED, STARTED, PAID, SUBMITTED, ADMITTED)
 from waeup.kofa.browser import (
-    KofaPage, KofaEditFormPage, KofaAddFormPage, KofaDisplayFormPage,
+#    KofaPage, KofaEditFormPage, KofaAddFormPage, KofaDisplayFormPage,
     DEFAULT_PASSPORT_IMAGE_PATH)
+from waeup.kofa.browser.layout import (
+    KofaPage, KofaEditFormPage, KofaAddFormPage, KofaDisplayFormPage)
 from waeup.kofa.browser.interfaces import ICaptchaManager
 from waeup.kofa.browser.breadcrumbs import Breadcrumb
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 9217)
@@ -27,4 +27,5 @@
 from zope.schema.interfaces import (
     ValidationError, ISource, IContextSourceBinder)
+from waeup.kofa.browser.interfaces import IApplicantBase
 from waeup.kofa.schema import TextLineChoice, FormattedDate
 from waeup.kofa.interfaces import (
@@ -311,5 +312,5 @@
     'year'].order =  IApplicantsContainer['year'].order
 
-class IApplicantBaseData(IKofaObject):
+class IApplicantBaseData(IApplicantBase):
     """The data for an applicant.
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/async.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/async.pt	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/async.pt	(revision 9217)
@@ -0,0 +1,53 @@
+<html>
+  <head>
+    <title>Async testing</title>
+    <script type="text/javascript">
+$(document).ready(function() {
+  var myLoadingDiv = $("#progressbar");
+  var mySpinner = $("#loadspinner");
+  myLoadingDiv.progressbar({disabled:true});
+  function update() {
+  $.getJSON("status?",  {jobid: "4",}, function(data) {
+    if (data == null) {
+      myLoadingDiv.progressbar("disable");
+      myLoadingDiv.progressbar("value", 0);
+      mySpinner.html('No Data');
+      $("#msg").html("Syncing...");
+      clearInterval(intervalID);
+      //alert('No Data'):
+      }
+    else {
+      myLoadingDiv.progressbar("enable");
+      myLoadingDiv.progressbar("value", data.percent);
+      $("#msg").html(data.msg + ' (' + data.status + ') ');
+      //alert(data.msg);
+      if (data.percent == 100) {
+        mySpinner.html('Job finished.')
+        clearInterval(intervalID);
+        }
+      }
+  });}
+  intervalID = setInterval(update, 500);
+  //update();
+});
+    </script>
+  </head>
+  <body>
+    <h1>Async stuff</h1>
+    <div>Dispatcher: <span tal:content="view/dispatcher"></span></div>
+    <div>Queue: <span tal:content="view/queue"></span></div>
+    <div>Jobs: <span tal:content="structure view/job_status"></span></div>
+    <form method="POST">
+      <input type="submit" name="reload" value="reload" />
+      <input type="submit" name="start" value="start up" />
+    </form>
+    <div id="progressbar"
+	 class="ui-progressbar ui-widget ui-widget-content ui-corner-all">
+    </div>
+    <div id="msg">Hi there</div>
+    <div id="loadspinner">
+      <img src="" alt="Please wait..."
+	   tal:attributes="src view/spinner_url" />
+    </div>
+  </body>
+</html>
Index: main/waeup.kofa/trunk/src/waeup/kofa/async.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/async.py	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/async.py	(revision 9217)
@@ -0,0 +1,274 @@
+## $Id$
+##
+## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""Components for asynchronous job (task) handling, mainly based on
+:mod:`zc.async`.
+"""
+import grok
+import time
+import transaction
+import zc.async.dispatcher
+import zc.async.utils
+import zope.component
+from zc.async.job import Job as AsyncJob
+from zc.async.queue import getDefaultQueue
+from zc.async.interfaces import IJob, ObjectAdded
+from ZODB.utils import u64
+from zope.component.hooks import getSite
+from zope.event import notify
+from waeup.kofa.interfaces import (
+    IJobManager, IProgressable, IJobContainer, WAEUP_KEY,
+    )
+
+def compute(num, duration=60):
+    """A convenience function to test asynchronous jobs.
+
+    `duration` gives the seconds, this job should (artificially) need
+    for completing.
+    """
+    start = time.time()
+    end = start + duration
+    print "MyJob starts computation at ", start
+    myjob = zc.async.local.getJob()
+    print "MyJob's job: ", zc.async.local.getJob()
+    print "MyJob's queue: ", zc.async.local.getQueue(), list(
+        zc.async.local.getQueue())
+    while True:
+	if time.time() > end:
+	    break
+	time.sleep(1)
+        percent = (time.time() - start) * 100.0 / duration
+        if percent > 100.0:
+            percent = 100.0
+        print "MyJob percent: ", percent
+        zc.async.local.setLiveAnnotation('percent', percent)
+	print "MyJob does something at %s of %s" % (
+            time.time() - start, duration)
+        print "MyJob's annotations: %r" % dict(myjob.annotations)
+        print "MyJob's percent: %r" % zc.async.local.getLiveAnnotation(
+            'percent')
+    zc.async.local.setLiveAnnotation('percent', 100.0)
+    return num * 2
+
+#
+# Content components
+#
+class ProgressableJob(AsyncJob):
+    """A job that can indicate its progress via a `percent` attribute.
+    """
+    grok.implements(IJob, IProgressable)
+    grok.provides(IJob)
+    percent = None
+
+
+def get_job_id(persisted_job):
+    """Get the object id of an already persisted job.
+
+    The `persisted_job` must provide a `_p_oid` attribute.
+    """
+    job_id = u64(persisted_job._p_oid)
+    return "%s" % job_id
+
+class JobContainer(grok.Container):
+    """A container for :class:`IKofa` jobs.
+    """
+    grok.implements(IJobContainer)
+
+
+class JobManager(grok.GlobalUtility):
+    """A manager for asynchronous running jobs (tasks).
+
+    Registered as a global utility for the
+    `waeup.kofa.interfaces.IJobManager` interface.
+
+    This is the central location for managing asynchronous running
+    jobs/tasks.
+
+    It works roughly like this: for usual tasks it looks up some
+    JobContainer installed in a ZODB database root (the installation
+    can happen during startup; see the respective installer classes
+    and functions in this module) and then interacts with this
+    JobContainer.
+
+    The optional `site` parameter for most methods in here serves for
+    finding the databases' roots. It is sufficient to pass any
+    persisted object (or more precisely: some object with a valid
+    ``_p_jar__`` attribte). As long as some site was already set (for
+    instance during regular requests), the site is looked up
+    automatically and you don't have to pass the `site` parameter
+    then. So, in most cases you won't have to give a `site` parameter.
+    """
+    grok.implements(IJobManager)
+    grok.provides(IJobManager)
+
+    def _get_site(self, site):
+        if site is None:
+            site = getSite()
+            if site is None:
+                raise LookupError('cannot find a valid site')
+        return site
+
+    def _get_jobs_container(self, site):
+        # in fact we need _some_ persisted object, not necessarily a site
+        return site._p_jar.root()[WAEUP_KEY]
+
+    def put(self, job, site=None):
+        """Start the `job` and store it in local `site`.
+
+        The `job` must be an `IJob` instance.
+
+        It will be put into the default queue and then stored in local
+        site. The status of the job can be seen immediately in
+        `job.status`.
+
+        Please specify special treatments like `begin_after` or
+        `begin_by` by setting the respectives attributes of the job
+        itself.
+        """
+        site = self._get_site(site)
+        container = self._get_jobs_container(site)
+        transaction.begin()
+        queue = getDefaultQueue(site)
+        new_job = queue.put(job)
+        job_id = get_job_id(new_job)
+        container[job_id] = new_job
+        transaction.commit()
+        return job_id
+
+    def get(self, job_id, site=None):
+        """Get the job with `job_id` from local `site`.
+
+        If `job_id` cannot be found, ``None`` is returned. This
+        suitable e.g. when used with a traverser.
+        """
+        site = self._get_site(site)
+        container = self._get_jobs_container(site)
+        return container.get(job_id, None)
+
+    def jobs(self, site=None):
+        """Get all stored jobs as an iterable.
+
+        Result provides tuples (JOB_ID, JOB_OBJECT).
+        """
+        site = self._get_site(site)
+        container = self._get_jobs_container(site)
+        for job_id, job in container.items():
+            yield (job_id, job)
+
+    def remove(self, job_id, site=None):
+        """Remove job with `job_id` from local job container.
+
+        If no such job can be found this is silently ignored.
+
+        Please note: removing a job from the job container does not
+        mean to stop its execution (if it wasn't started yet or is
+        currently running).
+        """
+        site = self._get_site(site)
+        container = self._get_jobs_container(site)
+        if job_id in container.keys():
+            del container[job_id]
+        return
+
+    def start_test_job(self, duration=60, site=None):
+        """Start a test job.
+
+        A method for testing the general asynchronous functionality of
+        waeup.kofa. The test job started here executes the local
+        :func:`compute` function with ``23`` as argument.
+        """
+        job = AsyncJob(compute, 23, duration)
+        job_id = self.put(job, site=site)
+        return job_id
+
+class JobManagerTraverser(grok.Traverser):
+    """A traverser for the global ``IJobManager``.
+
+    Looks up jobs by job_id and returns the respective job if it
+    can be found.
+    """
+    grok.context(IJobManager)
+
+    def traverse(self, name):
+        # ``None`` if name cannot be found.
+        return self.context.get(name)
+
+##
+## configuration (permissions, subscribers, etc.) ...
+##
+
+class ViewJobs(grok.Permission):
+    grok.name('waeup.viewJobs')
+
+class ManageJobs(grok.Permission):
+    grok.name('waeup.manageJobs')
+
+class JobContainerInstaller(object):
+    """Install a JobContainer in root of given DB.
+
+    Instances of this installer can be called when a Zope instance
+    comes up (i.e. when an IDatabaseOpenedEvent was triggered).
+
+    It looks for some database named as in `db_name` and installs a
+    job container in the root of this database (``None`` by default)
+    if it does not exist already.
+    """
+    def __init__(self, db_name=None):
+        # This IDatabaseOpenedEvent will be from zope.app.appsetup if that
+        # package is around
+        zope.component.adapter(zc.async.interfaces.IDatabaseOpenedEvent)(self)
+        self.db_name = db_name
+        return
+
+    def __call__(self, ev):
+        db = ev.database
+        tm = transaction.TransactionManager()
+        conn = db.open(transaction_manager=tm)
+        tm.begin()
+        try:
+            try:
+                root = conn.root()
+                if WAEUP_KEY in root:
+                    return
+                if self.db_name is not None:
+                    other = conn.get_connection(self.db_name)
+                    container = other.root()[WAEUP_KEY] = JobContainer()
+                    other.add(container)
+                else:
+                    container = JobContainer()
+                root[WAEUP_KEY] = container
+                notify(ObjectAdded(container, root, WAEUP_KEY))
+                tm.commit()
+                zc.async.utils.log.info('job container added')
+            except:
+                tm.abort()
+                raise
+        finally:
+            conn.close()
+        return
+
+#: Can be used as event subscriber from ZCML; installs a job container
+#: in default database (named ``''``) root.
+job_container_installer = JobContainerInstaller()
+
+#: An installer instance that installs a job container in a ZODB
+#: called ``async`` - this name is used in several components of the
+#: `zc.async` package we don't want to reimplement here.
+#:
+#: To use this installer as an event subscriber by ZCML, make sure the
+#: instance provides also a ZODB called `async`.
+multidb_job_container_installer = JobContainerInstaller(db_name='async')
Index: main/waeup.kofa/trunk/src/waeup/kofa/async_multidb.zcml
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/async_multidb.zcml	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/async_multidb.zcml	(revision 9217)
@@ -0,0 +1,4 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<configure xmlns="http://namespaces.zope.org/zope">
+  <subscriber handler=".async.multidb_job_container_installer" />
+</configure>
Index: main/waeup.kofa/trunk/src/waeup/kofa/async_single.zcml
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/async_single.zcml	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/async_single.zcml	(revision 9217)
@@ -0,0 +1,4 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<configure xmlns="http://namespaces.zope.org/zope">
+  <subscriber handler=".async.job_container_installer" />
+</configure>
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/__init__.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/__init__.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/__init__.py	(revision 9217)
@@ -1,8 +1,8 @@
 import os
 
-from waeup.kofa.browser.layout import (
-    KofaPage, KofaForm, KofaLayout, KofaDisplayFormPage, KofaEditFormPage,
-    KofaAddFormPage, NullValidator)
-from waeup.kofa.browser.pages import ContactAdminForm
+#from waeup.kofa.browser.layout import (
+#    KofaPage, KofaForm, KofaLayout, KofaDisplayFormPage, KofaEditFormPage,
+#    KofaAddFormPage, NullValidator)
+#from waeup.kofa.browser.pages import ContactAdminForm
 
 IMAGE_PATH = os.path.join(
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/async.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/async.py	(revision 9217)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/async.py	(revision 9217)
@@ -0,0 +1,151 @@
+import grok
+from zc.async.interfaces import COMPLETED, NEW
+from zope.interface import Interface
+from waeup.kofa.async import IJob, IJobManager
+from waeup.kofa.browser.layout import KofaPage
+from waeup.kofa.browser.resources import jquery, loadbar
+from waeup.kofa.interfaces import IKofaObject, IDataCenter
+from waeup.kofa.interfaces import MessageFactory as _
+
+grok.templatedir('templates')
+grok.context(IKofaObject)
+
+loadingbar_template = '''
+<input id="status_url" type="hidden" name="status_url" value="%s" />
+<div id="loadbar">%%s</div>
+'''
+
+class LoadingBar(grok.ViewletManager):
+    grok.name('loadingbar')
+
+class LoadingBarViewlet(grok.Viewlet):
+    grok.context(Interface)
+    grok.viewletmanager(LoadingBar)
+
+    _running_exports = None
+
+    def getRunningExports(self):
+        """Returns running exports as list of tuples.
+
+        Only exports triggered by the current user (identified by
+        principal.id) are returned.
+
+        Each tuple has the form (<STATUS>, <STATUS_TITLE>, <EXPORTER_NAME>).
+
+        ``STATUS``:
+           the status as machine readable string (something like
+           ``'completed'``)
+
+        ``STATUS_TITLE``:
+           status of export as translated string.
+
+        ``EXPORTER_NAME``:
+           string representing the exporter title used when triggering
+           the export job.
+        """
+        result = self.context.get_export_jobs_status(self.user_id)
+        return result
+
+    def update(self):
+        self.user_id = self.request.principal.id
+        self.exports = self.getRunningExports()
+        self.uncompleted = [x for x in self.exports if x[0] != 'completed']
+        loadbar.need()
+
+    def render(self):
+        status_url = self.view.url('status')
+        template = loadingbar_template % (status_url,)
+        content = ''
+        return template % content
+
+class DataCenterJSON(grok.JSON):
+    grok.context(IDataCenter)
+
+    def status(self):
+        """Get status of currently handled export jobs for users.
+
+        The result is a set of valus useful for JavaScript handlers to
+        update some page handling data center exports.
+
+        Returns a mapping::
+
+          {html=<string>, interval=<int>, reload=<bool>}
+
+        where `html` is some HTML code that might be shown in a
+        loading bar section.
+
+        `interval` is the time in microseconds after which the loading
+        bar should be reloaded (by a new JSON call). If the value is
+        zero, then the loading bar should not be renewed and further
+        JSON calls be canceled.
+
+        `reload` is a hint to tell, whether the complete page should
+        be reloaded or not. Reloading is neccessary, if the export
+        file creation finished and download buttons or similar should
+        appear.
+        """
+        user_id = self.request.principal.id
+        jobs = self.context.get_export_jobs_status(user_id)
+        uncompleted = [x for x in jobs if x[0] != 'completed']
+        result = dict(
+            html='', interval=0, reload=False)
+        if len(uncompleted):
+            html = '<em>%s</em>' % (_("Please wait..."),)
+            result.update(interval=500, html=html)
+        else:
+            if len(jobs):
+                result.update(reload=True)
+        return result
+
+
+class JobManagerView(KofaPage):
+    """The main view for the job container.
+    """
+    grok.name('index.html')
+    grok.context(IJobManager)
+    grok.template('virtjobscontainerindex')
+    grok.require('waeup.manageJobs')
+
+    def jobs(self):
+        for job_id, job in sorted(self.context.jobs(),
+                                  cmp=lambda x, y: cmp(int(x[0]), int(y[0]))):
+            link = self.url(self.context, job_id)
+            removable = job.status in (COMPLETED, NEW)
+            yield dict(
+                job_id = job_id,
+                job = job,
+                link = link,
+                status = job.status,
+                begin_after = job.begin_after,
+                begin_by = job.begin_by,
+                annotations = '%r' % [
+                    (x, y) for x, y in job.annotations.items()],
+                removable = removable,
+                failure = '%r' % getattr(job, 'traceback', None),
+                )
+
+    def update(self, START_NEW=None, REMOVE=None, job_id=None):
+        jquery.need()
+        if REMOVE and job_id:
+            self.context.remove(job_id)
+            self.flash('Removed job "%s"' % job_id)
+        if START_NEW:
+            self.context.start_test_job()                    #pragma NO COVER
+            self.flash('Started new test job "%s"' % job_id) #pragma NO COVER
+        return
+
+class JobView(grok.View):
+    grok.name('index.html')
+    grok.context(IJob)
+    grok.template('jobindex')
+    grok.require('waeup.manageJobs')
+
+    def percent(self):
+        value = self.context.annotations.get('percent', None)
+        if not value:
+            return
+        value = int(value+0.5)
+        return min(value, 100)
+
+    def update(self):
+        pass
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/breadcrumbs.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/breadcrumbs.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/breadcrumbs.py	(revision 9217)
@@ -26,7 +26,10 @@
     IConfigurationContainer, ISessionConfiguration)
 from waeup.kofa.interfaces import MessageFactory as _
-from waeup.kofa.browser import interfaces
-from waeup.kofa.browser.interfaces import (IBreadcrumb,
-    IBreadcrumbIgnorable, IBreadcrumbContainer)
+from waeup.kofa.browser.interfaces import (
+    IBreadcrumb, IBreadcrumbIgnorable, IBreadcrumbContainer, IKofaObject,
+    IUniversity, IFacultiesContainer, IUsersContainer, IDataCenter, IFaculty,
+    IDepartment, ICourse, ICertificate, ICoursesContainer, ICertificateCourse,
+    ICertificatesContainer,
+    )
 
 class Breadcrumb(grok.Adapter):
@@ -34,5 +37,5 @@
     """
     grok.provides(IBreadcrumb)
-    grok.context(interfaces.IKofaObject)
+    grok.context(IKofaObject)
     grok.name('index')
 
@@ -87,5 +90,5 @@
     """A breadcrumb for university index pages.
     """
-    grok.context(interfaces.IUniversity)
+    grok.context(IUniversity)
     title = _(u'Home')
     parent = None
@@ -100,5 +103,5 @@
     itself is bound to.
     """
-    grok.context(interfaces.IUniversity)
+    grok.context(IUniversity)
     grok.name('manage')
     title = _(u'Portal Settings')
@@ -113,5 +116,5 @@
     """A breadcrumb for faculty containers.
     """
-    grok.context(interfaces.IFacultiesContainer)
+    grok.context(IFacultiesContainer)
     title = _(u'Academics')
 
@@ -119,5 +122,5 @@
     """A breadcrumb for administration areas of University instances.
     """
-    grok.context(interfaces.IUniversity)
+    grok.context(IUniversity)
     grok.name('administration')
     title = _(u'Administration')
@@ -145,5 +148,5 @@
     """A breadcrumb for user containers.
     """
-    grok.context(interfaces.IUsersContainer)
+    grok.context(IUsersContainer)
     title = _(u'Portal Users')
     parent_viewname = 'administration'
@@ -152,5 +155,5 @@
     """A breadcrumb for data centers.
     """
-    grok.context(interfaces.IDataCenter)
+    grok.context(IDataCenter)
     title = _(u'Data Center')
     parent_viewname = 'administration'
@@ -159,5 +162,5 @@
     """A breadcrumb for faculties.
     """
-    grok.context(interfaces.IFaculty)
+    grok.context(IFaculty)
 
     @property
@@ -168,20 +171,20 @@
     """A breadcrumb for departments.
     """
-    grok.context(interfaces.IDepartment)
+    grok.context(IDepartment)
 
 class CourseBreadcrumb(FacultyBreadcrumb):
     """A breadcrumb for courses.
     """
-    grok.context(interfaces.ICourse)
+    grok.context(ICourse)
 
 class CertificateBreadcrumb(FacultyBreadcrumb):
     """A breadcrumb for certificates.
     """
-    grok.context(interfaces.ICertificate)
+    grok.context(ICertificate)
 
 class CoursesContainerBreadcrumb(Breadcrumb):
     """ We don't want course container breadcrumbs.
     """
-    grok.context(interfaces.ICoursesContainer)
+    grok.context(ICoursesContainer)
     grok.implements(IBreadcrumbIgnorable)
 
@@ -189,5 +192,5 @@
     """ We don't want course container breadcrumbs.
     """
-    grok.context(interfaces.ICertificatesContainer)
+    grok.context(ICertificatesContainer)
     grok.implements(IBreadcrumbIgnorable)
 
@@ -195,5 +198,5 @@
     """ We don't want course container breadcrumbs.
     """
-    grok.context(interfaces.ICertificateCourse)
+    grok.context(ICertificateCourse)
     @property
     def title(self):
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/captcha.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/captcha.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/captcha.py	(revision 9217)
@@ -28,5 +28,6 @@
 from zope.interface import Interface
 from zope.publisher.interfaces.http import IHTTPRequest
-from waeup.kofa.browser import KofaPage, resources
+from waeup.kofa.browser import resources
+from waeup.kofa.browser.layout import KofaPage
 from waeup.kofa.browser.interfaces import (
     ICaptchaRequest, ICaptchaResponse, ICaptcha, ICaptchaConfig,
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/interfaces.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/interfaces.py	(revision 9217)
@@ -21,5 +21,6 @@
 from zope.interface import Interface, Attribute
 from waeup.kofa.interfaces import (
-    IKofaObject, IUniversity, IUsersContainer, IDataCenter)
+    IKofaObject, IUniversity, IUsersContainer, IDataCenter, validate_email)
+from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.university.interfaces import (
     IFacultiesContainer, IFaculty, IFacultyAdd, IDepartment, IDepartmentAdd,
@@ -196,2 +197,33 @@
         If no `title` is given, nothing will be rendered.
         """
+
+class IChangePassword(IKofaObject):
+    """Interface needed for change pasword page.
+
+    """
+    identifier = schema.TextLine(
+        title = _(u'Unique Identifier'),
+        description = _(
+            u'User Name, Student or Applicant Id, Matriculation or '
+            u'Registration Number'),
+        required = True,
+        readonly = False,
+        )
+
+    email = schema.ASCIILine(
+        title = _(u'Email Address'),
+        required = True,
+        constraint=validate_email,
+        )
+
+class IStudentNavigationBase(IKofaObject):
+    """Objects that provide student navigation (whatever it is) should
+       implement this interface.
+    """
+    student = Attribute('''Some student object that has a '''
+                        ''' `display_fullname` attribute.''')
+
+class IApplicantBase(IKofaObject):
+    """Some Applicant.
+    """
+    display_fullname = Attribute('''Fullname.''')
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py	(revision 9216)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py	(revision 9217)
@@ -36,8 +36,7 @@
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.utils.helpers import to_timezone
-from waeup.kofa.browser.interfaces import ITheme
+from waeup.kofa.browser.interfaces import (
+    ITheme, IStudentNavigationBase, IApplicantBase)
 from waeup.kofa.browser.theming import get_all_themes, KofaThemeBase
-from waeup.kofa.students.interfaces import IStudentNavigation
-from waeup.kofa.applicants.interfaces import IApplicant
 from waeup.kofa.authentication import get_principal_role_manager
 
@@ -288,5 +287,5 @@
         """Return the student name.
         """
-        if IStudentNavigation.providedBy(self.context):
+        if IStudentNavigationBase.providedBy(self.context):
             return self.context.student.display_fullname
         return
@@ -295,5 +294,6 @@
         """Return the applicant name.
         """
-        if IApplicant.providedBy(self.context):
+        if IApplicantBase.providedBy(self.context):
+            # XXX: shouldn't that be `display_fullname???`
             return self.context.fullname
         return
